#include "QdpFtdcTraderApi.h"
#include <iostream>
#include <cstdlib>
#include <string.h>
#include <stdio.h>
#include <thread>
#include <chrono>

#ifdef WIN32
#define WINDOWS
#endif
using namespace std;

// ¼Ƿɵı־
// ͹˾
TQdpFtdcBrokerIDType g_chBrokerID;
// û
TQdpFtdcUserIDType g_chUserID;
// Ͷ߱
TQdpFtdcInvestorIDType g_chInvestorID;
// û󱨵
int g_nOrdLocalID = 0;
/// API
CQdpFtdcTraderApi *g_pTraderApi = NULL;

void OrderFunc();

void ReqQryTopic(int RequestID);

void ReqUserPasswordUpdate(int RequestID);

void ReqSubPrdTradeFlow(int RequestID);

void ReqUnSubPrdTradeFlow(int RequestID);

void ReqForQuoteInsert(int RequestID);

void ReqQryForQuote(int RequestID);

void ReqQryMarketData(int RequestID);

void ReqQryExchange(int &RequestID);

void ReqQryTrade(int &RequestID);

void ReqQryOrder(int &RequestID);

void ReqQuoteAction(int RequestID);

void ReqQuoteInsert(int RequestID);

void ReqSubmitUserSystemInfo(int RequestID);

void ReqQryFrontInfo(int RequestID);

int ReqSetClientMaxSigVol(int RequestID);

int ReqOrderAction(int RequestID);

int ReqOrderInsert(int RequestID);

int ReqQryUserInvestor(int RequestID);

int ReqQryInvestorAccount(int RequestID);

int ReqQryInvestorOptionFee(int RequestID);

int ReqQryInvestorMargin(int RequestID);

int ReqQryInstrument(int RequestID);

int ReqQrySGEDeferRate(int RequestID);

int ReqQryInvestorFee(int RequestID);

int ReqQryInvestorPosition(int RequestID);

class CTraderSpi : public CQdpFtdcTraderSpi
{
public:
    CTraderSpi(CQdpFtdcTraderApi *pUserApi) : m_pTraderApi(pUserApi) {}
    ~CTraderSpi() {orderThread.join();};

    // ʵCTraderSpiĸӿ
    virtual void OnFrontConnected()
    {
        std::cout << "OnFrontConnected\n";
        //Ӻ¼
        ReqLogin();
        //Ӻ֤
        ReqAuth();
    };

    void ReqLogin()
    {
        CQdpFtdcReqUserLoginField reqUserLogin;

        strcpy(reqUserLogin.UserProductInfo, "test");
        strcpy(reqUserLogin.BrokerID, g_chBrokerID);
        strcpy(reqUserLogin.UserID, g_chUserID);
        strcpy(reqUserLogin.Password, "1");
        // ½
        m_pTraderApi->ReqUserLogin(&reqUserLogin, 0);
    }

    void ReqAuth()
    {
        CQdpFtdcAuthenticateField reqfield;
        strcpy(reqfield.BrokerID, g_chBrokerID);
        strcpy(reqfield.UserID, g_chUserID);
        strcpy(reqfield.UserProductInfo, "test");
        strcpy(reqfield.AppID, "quantdo_InfiniV8_1");
        strcpy(reqfield.AuthCode, "58ba7c405b18960d31870d5095bfd06a");
        // ֤
        m_pTraderApi->ReqAuthenticate(&reqfield, 0);
    }

    virtual void OnFrontDisconnected(int nReason) {
        std::cout << "ӶϿ..." << "\n";
    };

    virtual void OnRspUserLogin(CQdpFtdcRspUserLoginField *pRspUserLogin, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "û: " << g_chUserID << "¼ʧ; ԭ: " << pRspInfo->ErrorMsg;
            // REPORT_EVENT(LOG_ERROR, "CTraderSpi::OnRspUserLogin", "Login result: %s", "failed");
            return;
        }
        
        std::cout << "¼ɹʼ..." << "\n";

        // ߳ڱͲѯ ֹص
        orderThread = std::thread(OrderFunc);
    };

    virtual void OnRspUserLogout(CQdpFtdcRspUserLogoutField *pRspUserLogout, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if(pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "ûǳʧ;ԭ:" << pRspInfo->ErrorMsg << "\n";
            return;
        }
        if(pRspInfo == NULL){
            std::cout << "OnRspUserLogout=NULL!\n";
        }
    };

    virtual void OnRspUserPasswordUpdate(CQdpFtdcUserPasswordUpdateField *pUserPasswordUpdate, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if(pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "ûʧ;ԭ:" << pRspInfo->ErrorMsg << "\n";
            return;
        }
        if(pRspInfo == NULL){
            std::cout << "OnRspUserPasswordUpdate=NULL!\n";
        }
    };

    virtual void OnRspAuthenticate(CQdpFtdcRtnAuthenticateField *pRtnAuthenticate, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "û֤ʧ; ԭ: " << pRspInfo->ErrorMsg << "\n";
            // REPORT_EVENT(LOG_ERROR, "CAccountSpi::OnRspUserLogin", "Login result: %s", "failed");
            return;
        }
        if (pRspInfo == NULL)
        {
            std::cout << "OnRspAuthenticate=NULL!\n";
        }
        TQdpFtdcAppTypeType *appType = pRtnAuthenticate->AppID;

        std::cout << "֤ɹͻΪ: " << appType << "\n";

        // ֤ɹ¼
        ReqLogin();
    };
    // traderSPI
    virtual void OnRtnTrade(CQdpFtdcTradeField *pTrade)
    {
        std::cout << "OnRtnTrade: OrderSysID=" << pTrade->OrderSysID << ", TradeID=" << pTrade->TradeID << "\n";
    };
    virtual void OnRtnOrder(CQdpFtdcOrderField *pOrder) {
        // store OrderSysID
        std::cout << "OnRtnOrder: OrderSysID=" << pOrder->OrderSysID << ", InstrumentID=" << pOrder->InstrumentID << "\n";
    };
    virtual void OnRtnInstrumentStatus(CQdpFtdcInstrumentStatusField *pInstrumentStatus) {};

    // virtual void OnErrRtnOrderInsert(CQdpFtdcInputOrderField* pInputOrder, CQdpFtdcRspInfoField* pRspInfo){};

    virtual void OnRspOrderAction(CQdpFtdcOrderActionField *pOrderAction, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if(pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "ûʧ;ԭ:" << pRspInfo->ErrorMsg << "\n";
            return;
        }
        if(pRspInfo == NULL){
            std::cout << "OnRspOrderAction=NULL!\n";
        }
    };
    // QuerySPI
    virtual void OnRspQryUserInvestor(CQdpFtdcRspUserInvestorField *pRspUserInvestor, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        std::cout << "InvestorID:" << pRspUserInvestor->InvestorID
                  << "ӦUserID:" << pRspUserInvestor->UserID << "\n";
    };
    // virtual void OnRspQryInvestor(CQdpFtdcRspQryInvestorField *pRspQryInvestor, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast){};
    virtual void OnRspQryInvestorPosition(CQdpFtdcRspInvestorPositionField *pRspInvestorPosition, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        std::cout << "ֲֲѯ\n";
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "ֲֲѯûʧ; : " << pRspInfo->ErrorID
                      << ", ԭ: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID << "\n";
            return;
        }

        if (pRspInvestorPosition != NULL)
        {
            // ֲֳܳɱ ֲܳ Լ
            std::cout << "ֲֲѯɹ, ռñ֤=[" << pRspInvestorPosition->UsedMargin
                      << "], ᱣ֤=[" << pRspInvestorPosition->FrozenMargin << "], Լ=[" << pRspInvestorPosition->InstrumentID << "], Ȩ=[" << pRspInvestorPosition->FrozenPremium << "], ֲӯ=[" << pRspInvestorPosition->PositionProfit << "], ճֲֳɱ=[" << pRspInvestorPosition->PositionCost << "], ֲ=[" << pRspInvestorPosition->TodayPosition << "];\n";
        }
    };
    virtual void OnRspQryInstrument(CQdpFtdcRspInstrumentField *pRspInstrument, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        std::cout << "ѯԼ\n";

        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "ѯԼŲʧ; : " << pRspInfo->ErrorID
                      << ", ԭ: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID << "\n";
            return;
        }

        if (pRspInstrument != NULL)
        {
            std::cout << "ѯԼŲɹ, =[" << pRspInstrument->ExchangeID
                      << "], Լ=[" << pRspInstrument->InstrumentID 
                      << "], =[" << pRspInstrument->VolumeMultiple
                      //<< "], InstrumentIDNum=" << pRspInstrument->InstrumentIDNum //API7.0汾УʱдInstrumentIDNum
                      << "], Լ=[" << pRspInstrument->InstrumentName << "], ۵λ=[" << pRspInstrument->PriceTick << "], ͣ=[" << pRspInstrument->LowerLimitPrice << "], =[" << pRspInstrument->PreSettlementPrice << "], Լ״̬=[" << pRspInstrument->InstrumentStatus << "], ǰǷ=[" << pRspInstrument->IsTrading << "],  | ƻ׼ | ִм۸=[" << pRspInstrument->OpenDate
                      << "|" << pRspInstrument->BasisPrice << "|" << pRspInstrument->StrikePrice << "];\n";
        }
    };
    virtual void OnRspQryInvestorAccount(CQdpFtdcRspInvestorAccountField *pRspInvestorAccount, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        std::cout << "Ͷʽ˻ѯ\n";

        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "Ͷʽ˻ѯʧ; : " << pRspInfo->ErrorID
                      << ", ԭ: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID << "\n";
            return;
        }

        if (pRspInvestorAccount != NULL)
        {
            std::cout << "ɹ, ʽ˺=[" << pRspInvestorAccount->AccountID
                      << "], ϴν׼=[" << pRspInvestorAccount->PreBalance << "], տʽ=[" << pRspInvestorAccount->PreAvailable << "], ƽ/ֲӯ=[" << pRspInvestorAccount->CloseProfit << "|" << pRspInvestorAccount->PositionProfit << "], =[" << pRspInvestorAccount->Fee << "], =[" << pRspInvestorAccount->FrozenFee << "], Ȩ=[" << pRspInvestorAccount->FrozenPremium << "], ռñ֤=[" << pRspInvestorAccount->Margin << "], ᱣ֤=[" << pRspInvestorAccount->FrozenMargin << "], ʽ=[" << pRspInvestorAccount->Available << "], ̬Ȩ=[" << pRspInvestorAccount->DynamicRights << "], ׼=[" << pRspInvestorAccount->Balance << "], /=[" << pRspInvestorAccount->Deposit << "|" << pRspInvestorAccount->Withdraw << "], =[" << pRspInvestorAccount->Fee << "];\n";
        }

        if (pRspInvestorAccount == NULL)
        {
            std::cout << "pRspInvestorAccount=NULL\n";
        }
    };
    virtual void OnRspQryInvestorMargin(CQdpFtdcInvestorMarginField *pInvestorMargin, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        std::cout << "֤ʲѯ\n";
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "֤ʲѯʧ; : " << pRspInfo->ErrorID
                      << ", ԭ: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID << "\n";
            return;
        }
        if (pInvestorMargin != NULL)
        {
            std::cout << "֤ʲѯɹ, InstrumentID=[" << pInvestorMargin->InstrumentID
                      << "], LongMarginRate=[" << pInvestorMargin->LongMarginRate
                      << "], LongMarginAmt=[" << pInvestorMargin->LongMarginAmt
                      << "], ShortMarginRate=[" << pInvestorMargin->ShortMarginRate
                      << "], ShortMarginAmt=[" << pInvestorMargin->ShortMarginAmt
                      << "], HedgeFlag=[" << pInvestorMargin->HedgeFlag
                      << "];" << "\n";
        }
    };
    virtual void OnRspQryInvestorFee(CQdpFtdcInvestorFeeField *pInvestorFee, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        std::cout << "ʲѯ\n";

        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "ʲѯʧ; : " << pRspInfo->ErrorID
                      << ", ԭ: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID << "\n";
            return;
        }

        if (pInvestorFee == NULL)
            std::cout << "OnRspQryInvestorFee pInvestorFee=NULL\n";
    };
    virtual void OnRspQryInvestorOptionFee(CQdpFtdcRspInvestorOptionFeeField *pRspInvestorOptionFee, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        std::cout << "Ȩʲѯ\n";

        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "Ȩʲѯʧ; : " << pRspInfo->ErrorID
                      << ", ԭ: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID << "\n";
            return;
        }
    };

    virtual void OnRspQryMarketData(CQdpFtdcMarketDataField *pMarketData, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        std::cout << "Լѯ\n";
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "Լѯʧ; : " << pRspInfo->ErrorID
                      << ", ԭ: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID << "\n";
            return;
        }
    };

    virtual void OnRspQryExchange(CQdpFtdcRspExchangeField *pRspExchange, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        std::cout << "ѯ\n";
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "ѯʧ; : " << pRspInfo->ErrorID
                      << ", ԭ: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID << "\n";
            return;
        }
    };
    virtual void OnRspQryTrade(CQdpFtdcTradeField *pTrade, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast)
    {
        if (pTrade == NULL)
            std::cout << "OnRspQryTrade pTrade=NULL\n";

        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "ûʧ; : " << pRspInfo->ErrorID
                      << ", ԭ: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID << "\n";
            return;
        }
    };

    virtual void OnRspQryOrder(CQdpFtdcOrderField *pOrder, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        // ѯ
        if (pOrder == NULL)
            std::cout << "OnRspQryOrder pOrder=NULL\n";

        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "ѯʧ; : " << pRspInfo->ErrorID
                        << ", ԭ: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID;
            return;
        }
    };

   
    virtual void OnRspQuoteAction(CQdpFtdcQuoteActionField *pQuoteAction, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "ûʧ; : " << pRspInfo->ErrorID
                        << ", ԭ: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID;
            return;
        }
        if (pQuoteAction != NULL)
        {
            
            std::cout << "۳ɹ, UserOrderLocalID=[" << pQuoteAction->UserOrderLocalID
                << "], OrderSysID=[" << pQuoteAction->OrderSysID
                << "];\n";
        }
    };
   
    virtual void OnRtnQuote(CQdpFtdcQuoteField *pQuote) {
        // ۻر
        std::cout << "OnRtnQuote/ۻر, OrderSysID=" << pQuote->OrderSysID << ", UserOrderLocalID=" << pQuote->UserOrderLocalID << "\n";
    };
    
    virtual void OnRspOrderInsert(CQdpFtdcInputOrderField *pRspInputOrder, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "µʧ, ԭ: " << pRspInfo->ErrorMsg << "; :" << pRspInfo->ErrorID << "\n";
            return;
        }

        if (pRspInputOrder != NULL)
	    {
             std::cout << "µɹ,LimitPrice=[" << pRspInputOrder->LimitPrice
                << "],InstrumentID=[" << pRspInputOrder->InstrumentID
                << "],Volume=[" << pRspInputOrder->Volume
                << "],UserOrderLocalID=[" << pRspInputOrder->UserOrderLocalID
                << "],OrderSysID=[" << pRspInputOrder->OrderSysID
                << "];\n" ;
        }
    };

    virtual void OnRspQryForQuote(CQdpFtdcForQuoteField *pForQuote, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if( pRspInfo != NULL && pRspInfo->ErrorID != 0){
            std::cout << "ѯ۲ѯʧ; : " << pRspInfo->ErrorID << "\n";
            return;
        }

        if( pForQuote == NULL){
            std::cout << "OnRspQryForQuote pInputForQuote=NULL\n";
        }
    };

    virtual void OnRspForQuoteInsert(CQdpFtdcInputForQuoteField *pInputForQuote, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "ѯ¼ʧ; : " << pRspInfo->ErrorID << "\n";
            return;
        }

        if (pInputForQuote == NULL){
            std::cout << "OnRspForQuoteInsert pInputForQuote=NULL\n";
        }
    };

    virtual void OnRspQuoteInsert(CQdpFtdcInputQuoteField *pRspInputQuote, CQdpFtdcRspInfoField *pRspInfo, int nRequestID, bool bIsLast) {
        if (pRspInfo != NULL && pRspInfo->ErrorID != 0)
        {
            std::cout << "¼ʧ; : " << pRspInfo->ErrorID
                        << ", ԭ: " << pRspInfo->ErrorMsg << ", RequestID: " << nRequestID << "\n";
            return;
        }

        if (pRspInputQuote != NULL)
        {
            std::cout << "۳ɹ,InstrumentID=[" << pRspInputQuote->InstrumentID
                      << "],AskPrice=[" <<  pRspInputQuote->AskPrice
                      << "],AskVolume=[" << pRspInputQuote->AskVolume
                      << "],BidPrice=[" << pRspInputQuote->BidPrice
                      << "],BidVolume=[" << pRspInputQuote->BidVolume << "\n";
        }
    };

private:
    CQdpFtdcTraderApi *m_pTraderApi;
    std::thread orderThread;
    int session_id;
};

void ReqQryTopic(int RequestID)
{
    CQdpFtdcDisseminationField t_field;
    memset(&t_field, 0, sizeof(t_field));
    t_field.SequenceNo = 1;
    t_field.SequenceSeries = 2000;
    g_pTraderApi->ReqQryTopic(&t_field, RequestID);
}

void ReqUserPasswordUpdate(int RequestID)
{
    CQdpFtdcUserPasswordUpdateField t_field;
    memset(&t_field, 0, sizeof(t_field));
    strcpy(t_field.BrokerID, g_chBrokerID);
    strcpy(t_field.UserID, g_chUserID);
    strcpy(t_field.OldPassword, "1");
    strcpy(t_field.NewPassword, "1");
    g_pTraderApi->ReqUserPasswordUpdate(&t_field, RequestID);
}

void ReqSubPrdTradeFlow(int RequestID)
{
    CQdpFtdcSpecificInstrumentField t_field;
    memset(&t_field, 0, sizeof(t_field));
    strcpy(t_field.InstrumentID, "CFFEX");
    g_pTraderApi->ReqSubPrdTradeFlow(&t_field, RequestID);
}

void ReqUnSubPrdTradeFlow(int RequestID)
{
    CQdpFtdcSpecificInstrumentField t_field;
    memset(&t_field, 0, sizeof(t_field));
    strcpy(t_field.InstrumentID, "CFFEX");
    g_pTraderApi->ReqUnSubPrdTradeFlow(&t_field, RequestID);
}

void ReqForQuoteInsert(int RequestID)
{
    CQdpFtdcInputForQuoteField a_field;
    memset(&a_field, 0, sizeof(a_field));
    strcpy(a_field.BrokerID, g_chBrokerID);
    strcpy(a_field.InvestorID, g_chInvestorID);
    strcpy(a_field.UserID, g_chUserID);
    strcpy(a_field.ExchangeID, "CFFEX");
    strcpy(a_field.InstrumentID, "IF2412");
    a_field.UserOrderLocalID = 5;
    g_pTraderApi->ReqForQuoteInsert(&a_field, RequestID);
}

void ReqQryForQuote(int RequestID)
{
    CQdpFtdcQryForQuoteField a_field;
    memset(&a_field, 0, sizeof(a_field));
    strcpy(a_field.BrokerID, g_chBrokerID);
    strcpy(a_field.InvestorID, g_chInvestorID);
    strcpy(a_field.ExchangeID, "CFFEX");
    strcpy(a_field.InstrumentID, "IF2412");
    g_pTraderApi->ReqQryForQuote(&a_field, RequestID);
}

void ReqQryMarketData(int RequestID)
{
    CQdpFtdcQryMarketDataField d_field;
    memset(&d_field, 0, sizeof(CQdpFtdcQryMarketDataField));
    strcpy(d_field.ExchangeID, "CFFEX");
    strcpy(d_field.InstrumentID, "IF2412");
    g_pTraderApi->ReqQryMarketData(&d_field, RequestID);
}

void ReqQryExchange(int &RequestID)
{
    CQdpFtdcQryExchangeField t_field;
    memset(&t_field, 0, sizeof(CQdpFtdcQryExchangeField));
    strcpy(t_field.ExchangeID, "CFFEX");
    g_pTraderApi->ReqQryExchange(&t_field, RequestID);
}

void ReqQryTrade(int &RequestID)
{
    CQdpFtdcQryTradeField t_field;
    memset(&t_field, 0, sizeof(CQdpFtdcQryTradeField));
    strcpy(t_field.BrokerID, g_chBrokerID);
    strcpy(t_field.UserID, g_chUserID);
    g_pTraderApi->ReqQryTrade(&t_field, RequestID);
}

void ReqQryOrder(int &RequestID)
{
    CQdpFtdcQryOrderField o_field;
    memset(&o_field, 0, sizeof(CQdpFtdcQryOrderField));
    strcpy(o_field.BrokerID, g_chBrokerID);
    strcpy(o_field.UserID, g_chUserID);
    g_pTraderApi->ReqQryOrder(&o_field, RequestID);
}

void ReqQuoteAction(int RequestID)
{
    CQdpFtdcQuoteActionField quote;
    memset(&quote, 0, sizeof(quote));
    quote.UserOrderLocalID = 5;
    strcpy(quote.ExchangeID, "CFFEX");
    quote.UserOrderActionLocalID = ++g_nOrdLocalID;
    quote.ActionFlag = QDP_FTDC_AF_Delete;
    g_pTraderApi->ReqQuoteAction(&quote, RequestID);
}

void ReqQuoteInsert(int RequestID)
{
    CQdpFtdcInputQuoteField quote;
    memset(&quote, 0, sizeof(quote));
    // Լ
    strcpy(quote.InstrumentID,"IF2412");
    // ر
    quote.UserOrderLocalID = g_nOrdLocalID;
    // ͶIDNum
    strcpy(quote.InvestorID,g_chInvestorID);

    // 
    quote.AskOffsetFlag = '0';
    quote.AskHedgeFlag = '0';
    quote.AskPrice = 1000;
    quote.AskVolume = 5;
    quote.AskOrderRef = g_nOrdLocalID++;
    // 
    quote.BidOffsetFlag = '0';
    quote.BidHedgeFlag = '0';
    quote.BidPrice = 1231;
    quote.BidVolume = 10;
    quote.BidOrderRef = g_nOrdLocalID++;

    g_pTraderApi->ReqQuoteInsert(&quote, RequestID);
}

void ReqSubmitUserSystemInfo(int RequestID)
{
    CQdpFtdcUserSystemInfoField a_field;
    memset(&a_field, 0, sizeof(a_field));

    g_pTraderApi->ReqSubmitUserSystemInfo(&a_field, RequestID);
}

void ReqQryFrontInfo(int RequestID)
{
    CQdpFtdcQryFrontInfoField a_field;
    memset(&a_field, 0, sizeof(a_field));
    strcpy(a_field.ExchangeID, "CFFEX");
    g_pTraderApi->ReqQryFrontInfo(&a_field, RequestID);
}

int ReqSetClientMaxSigVol(int RequestID)
{
    CQdpFtdcClientMaxSigVolField a_field;
    memset(&a_field, 0, sizeof(a_field));
    strcpy(a_field.BrokerID, g_chBrokerID);
    strcpy(a_field.ExchangeID, "CFFEX");
    strcpy(a_field.InvestorID, g_chInvestorID);
    a_field.HedgeFlag = '1';
    // strcpy(a_field.InstrumentID,"");
    // a_field.MaxSigVol = 10;
    return g_pTraderApi->ReqSetClientMaxSigVol(&a_field, RequestID);
}

int ReqOrderAction(int RequestID)
{
    CQdpFtdcOrderActionField ord;
    memset(&ord, 0, sizeof(ord));
    // 
    strcpy(ord.ExchangeID, "SHFE");
    // ıر
    ord.UserOrderLocalID = g_nOrdLocalID++;
    // γıر
    ord.UserOrderActionLocalID = 5;
    // 
    strcpy(ord.OrderSysID, "23");
    // ־
    ord.ActionFlag = QDP_FTDC_AF_Delete;

    return g_pTraderApi->ReqOrderAction(&ord, RequestID);
}

int ReqOrderInsert(int RequestID)
{
    CQdpFtdcInputOrderField ord;
    memset(&ord, 0, sizeof(ord));
    // Ͷ߱ (API7.0汾,InstrumentIDNumͨԼѯĻصȡ)
    strcpy(ord.InvestorID,g_chInvestorID);
    // Լ
    strcpy(ord.InstrumentID,"IF2412");
    // ر
    ord.UserOrderLocalID = g_nOrdLocalID;
    // 
    ord.OrderPriceType = QDP_FTDC_OPT_LimitPrice;
    // 
    // strcpy(&(ord.Direction) , "1");
    ord.Direction = QDP_FTDC_D_Buy;
    // ƽ־
    strcpy(&(ord.OffsetFlag), "0");
    // Ͷױ־
    strcpy(&(ord.HedgeFlag), "1");
    // ۸
    ord.LimitPrice = 3074;
    // 
    ord.Volume = 1;
    // Ч
    ord.TimeCondition = QDP_FTDC_TC_GFD;
    // ɽ
    ord.VolumeCondition = QDP_FTDC_VC_AV;

    return g_pTraderApi->ReqOrderInsert(&ord, RequestID);
}

int ReqQryUserInvestor(int RequestID)
{
    CQdpFtdcQryUserInvestorField a_field;
    memset(&a_field, 0, sizeof(CQdpFtdcQryUserInvestorField));
    strcpy(a_field.BrokerID, g_chBrokerID);
    strcpy(a_field.UserID, g_chUserID);
    return g_pTraderApi->ReqQryUserInvestor(&a_field, RequestID);
}

int ReqQryInvestorAccount(int RequestID)
{
    CQdpFtdcQryInvestorAccountField a_field;
    memset(&a_field, 0, sizeof(CQdpFtdcQryInvestorAccountField));
    strcpy(a_field.BrokerID, g_chBrokerID);
    strcpy(a_field.UserID, g_chUserID);
    strcpy(a_field.InvestorID, g_chInvestorID);
    return g_pTraderApi->ReqQryInvestorAccount(&a_field, RequestID);
}

int ReqQryInvestorOptionFee(int RequestID)
{
    CQdpFtdcQryInvestorOptionFeeField of_field;
    memset(&of_field, 0, sizeof(CQdpFtdcQryInvestorOptionFeeField));
    strcpy(of_field.BrokerID, g_chBrokerID);
    strcpy(of_field.UserID, g_chUserID);
    return g_pTraderApi->ReqQryInvestorOptionFee(&of_field, RequestID);
}

int ReqQryInvestorMargin(int RequestID)
{
    CQdpFtdcQryInvestorMarginField m_field;
    memset(&m_field, 0, sizeof(CQdpFtdcQryInvestorMarginField));
    return g_pTraderApi->ReqQryInvestorMargin(&m_field, RequestID);
}

int ReqQryInstrument(int RequestID)
{
    CQdpFtdcQryInstrumentField i_field;
    memset(&i_field, 0, sizeof(CQdpFtdcQryInstrumentField));
    return g_pTraderApi->ReqQryInstrument(&i_field, RequestID);
}

int ReqQrySGEDeferRate(int RequestID)
{
    CQdpFtdcQrySGEDeferRateField s_field;
    memset(&s_field, 0, sizeof(CQdpFtdcQrySGEDeferRateField));
    return g_pTraderApi->ReqQrySGEDeferRate(&s_field, RequestID);
}

int ReqQryInvestorFee(int RequestID)
{
    CQdpFtdcQryInvestorFeeField f_field;
    memset(&f_field, 0, sizeof(CQdpFtdcQryInvestorFeeField));
    strcpy(f_field.BrokerID, g_chBrokerID);
    strcpy(f_field.UserID, g_chUserID);
    return g_pTraderApi->ReqQryInvestorFee(&f_field, RequestID);
}

int ReqQryInvestorPosition(int RequestID)
{
    CQdpFtdcQryInvestorPositionField p_field;
    memset(&p_field, 0, sizeof(CQdpFtdcQryInvestorPositionField));
    strcpy(p_field.BrokerID, g_chBrokerID);
    strcpy(p_field.UserID, g_chUserID);
    strcpy(p_field.ExchangeID, "CFFEX");
    strcpy(p_field.InvestorID, g_chInvestorID);
    strcpy(p_field.InstrumentID, "IF2412");
    return g_pTraderApi->ReqQryInvestorPosition(&p_field, RequestID);
}

void OrderFunc()
{
    //ע˱ص Ҫʱ
    std::this_thread::sleep_for(std::chrono::microseconds(5000));
    std::cout << "ʼѯͱ\n";
    int RequestID = 0;
    // 
    int operationType = 0;
    while(1){
        //û ִжӦĲѯͱ
        std::cout << "ִжӦĲ:" << std::endl;
        std::cin >> operationType;
        switch (operationType)
        {
        case 1:
            // Լѯ
            ReqQryInstrument(RequestID);
            break;
        case 2:
            // ¼
            ReqOrderInsert(RequestID);
            break;
        case 3:
            // 
            ReqOrderAction(RequestID);
            break;
        case 4:
            // ͻϢֵ
            ReqSetClientMaxSigVol(RequestID);
            break;
        case 5:
            // Ͷ˻ѯ
            ReqQryUserInvestor(RequestID);
            break;
        case 6:
            // Ͷʽ˻ѯ
            ReqQryInvestorAccount(RequestID);
            break;
        case 7:
            // Ͷֲֲ߳ѯ
            ReqQryInvestorPosition(RequestID);
            break;
        case 8:
            // Ͷʲѯ
            ReqQryInvestorFee(RequestID);
            break;
        case 9:
            // Ͷ֤߱ʲѯ
            ReqQryInvestorMargin(RequestID);
            break;
        case 10:
            // ӷʲѯ
            ReqQrySGEDeferRate(RequestID);
            break;
        case 11:
            // ͶȨʲѯ
            ReqQryInvestorOptionFee(RequestID);
            break;
        case 12:
            // ¼
            // ReqQuoteInsert(RequestID);
            break;
        case 13:
            // ۲
            // ReqQuoteAction(RequestID);
            break;
        case 14:
            // ͨϢѯ
            ReqQryFrontInfo(RequestID);
            break;
        case 15:
            // ûɼϢ
            // ReqSubmitUserSystemInfo(RequestID);
            break;
        case 16:
            // ѯ
            ReqQryOrder(RequestID);
            break;
        case 17:
            // ɽѯ
            ReqQryTrade(RequestID);
            break;
        case 18:
            // ѯ
            ReqQryExchange(RequestID);
            break;
        case 19:
            // ʵʱѯ
            ReqQryMarketData(RequestID);
            break;
        case 20:
            // ѯ۲ѯ
            // ReqQryForQuote(RequestID);
            break;
        case 21:
            // ѯ¼
            // ReqForQuoteInsert(RequestID);
            break;
        case 22:
            // Ʒֽˮ
            //ReqSubPrdTradeFlow(RequestID);
            break;
        case 23:
            // ˶Ʒֽˮ
            //ReqUnSubPrdTradeFlow(RequestID);
            break;
        case 24:
            // û޸
            ReqUserPasswordUpdate(RequestID);
            break;
        case 25:
            //ѯ
            // ReqQryTopic(RequestID);
            break;
        default:
            break;
        }
        RequestID++;
    }
}

int main()
{
    // һCQdpFtdcTraderApiʵ
    CQdpFtdcTraderApi *pUserApi = CQdpFtdcTraderApi::CreateFtdcTraderApi();
    
    // api
    g_pTraderApi = pUserApi;
    
    //ȡAPI汾
    int max_version,min_version;
    std::cout << "API汾:" << CQdpFtdcTraderApi::GetVersion(max_version,min_version);
    
    // һ¼ʵ
    CTraderSpi *spi = new CTraderSpi(pUserApi);

    // ע¼ʵ
    pUserApi->RegisterSpi(spi);
    // ˽
    // QDP_TERT_RESTART:ӱտʼش
    // QDP_TERT_RESUME:ϴյ
    // QDP_TERT_QUICK:ֻ͵¼˽
    pUserApi->SubscribePrivateTopic(QDP_TERT_QUICK);
    // Ĺ
    // QDP_TERT_RESTART:ӱտʼش
    // QDP_TERT_RESUME:ϴյ
    // QDP_TERT_QUICK:ֻ͵¼˽
    pUserApi->SubscribePublicTopic(QDP_TERT_QUICK);

    // BrokerID  UserID
    strcpy(g_chBrokerID, "guofu");
    strcpy(g_chUserID, "admin");
    strcpy(g_chInvestorID, "0001"); 

    // ͶƼĵַעַ
    pUserApi->RegisterFront("tcp://192.168.92.12:30085");

    // ʱ
    pUserApi->SetHeartbeatTimeout(240);

    // ʹͻ˿ʼ̨
    pUserApi->Init();
    // ȴAPIʵ
    pUserApi->Join();
    // ͷAPIʵ
    pUserApi->Release();
    return 0;
}